<template>
    <el-menu :default-openeds="['1']">
        <el-submenu index="1">
            <template slot="title"><i class="el-icon-user-solid"></i>Connected users</template>
            <el-popover
                    placement="bottom"
                    trigger="click"
                    title="Написать письмо"
                    v-for="user in users" :key="user"
            >
                <el-input v-model="message" @keyup.enter.native="sendMessage(user)">
                    <el-button slot="append" @click="sendMessage(user)">send</el-button>
                </el-input>
                <el-menu-item slot="reference">{{user}}</el-menu-item>
            </el-popover>
        </el-submenu>
    </el-menu>
</template>

<script>
    import {mapState} from 'vuex';
  export default {
    name: "UserList",
    data: () => ({
      message: '',
    }),
    computed: {
      ...mapState(['connections']),
      users() {
        return this.connections.map(_=>_.peer)
      }
    },
    methods: {
      sendMessage(peer) {
        const message = this.message;
        if(!message)
          return ;
        const connection = this.connections.find(_=>_.peer === peer);
        if(!connection)
          return ;
        connection.send({
          type: 'message',
          data: message,
        });
        this.message = '';
      },
    }
  }
</script>

<style scoped>

</style>
